switch -- $::tcl_platform(platform) {
  unix    {
    package ifneeded tclperl 3.2 "load [file join $dir tclperl.so.3.2]"
  }
  windows {
    package ifneeded tclperl 3.2 "::perl::load_windows [file normalize $dir]"
  }
  default {error "Unsupported platform: \"$::tcl_platform(platform)\""}
}

namespace eval ::perl {
  ## Try to locate all available DLLs, and try to load all of them, until
  ## a DLL gets loaded.
  proc load_windows {dir} {
    global env
    ## Try to locate Perl installation path from registry.
    package require registry
    set current_version [registry get \
      {HKEY_LOCAL_MACHINE\SOFTWARE\ActiveState\ActivePerl} CurrentVersion]
    set install_dir [registry get \
      "HKEY_LOCAL_MACHINE\\SOFTWARE\\ActiveState\\ActivePerl\\$current_version"\
      {}]
    set perl58.dll_path [file native $install_dir\\bin]
    set oldPath $env(PATH)
    set env(PATH) "$env(PATH);${perl58.dll_path}"
    foreach dll [glob -directory $dir tclperl-3.2-*.dll] {
      if {![catch {load $dll} error]} {
        break
      }
    }
    set env(PATH) $oldPath
  };# load_windows
};# namespace ::perl
